﻿using System;
using System.ComponentModel;
using System.Collections.Generic;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace MVVMSample
{
    public class EmployeeViewModel : INotifyPropertyChanged
    {
        private Workbook employeeWorkbook;

        public Workbook EmployeeWorkbook
        {
            get
            {
                if (this.employeeWorkbook == null)
                {
                    this.employeeWorkbook = this.BuildWorkbook();
                }

                return this.employeeWorkbook;
            }
            set
            {
                if(this.employeeWorkbook != value)
                {
                    this.employeeWorkbook = value;
                    this.OnPropertyChanged("EmployeeWorkbook");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(string propertyName)
        {
            if (this.PropertyChanged != null)
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        private Workbook BuildWorkbook()
        {
            Workbook workbook = new Workbook();
            Worksheet worksheet = workbook.Worksheets.Add();

            List<Employee> employees = Employee.GetEmployees();

            for (int i = 0; i < employees.Count; i++)
            {
                Employee employee = employees[i];
    
                worksheet.Cells[i, 0].SetValue(employee.FirstName);
                worksheet.Cells[i, 1].SetValue(employee.LastName);
                worksheet.Cells[i, 2].SetValue(employee.JobTitle);
            }

            return workbook;
        }
    }
}
