﻿using System;
using System.Windows;
using Telerik.Windows.Controls;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace MVVMSample
{
    public static class SpreadsheetAttachedProperties
    {
        public static readonly DependencyProperty EmployeeWorkbookProperty =
            DependencyProperty.RegisterAttached("EmployeeWorkbook", typeof(Workbook), 
            typeof(SpreadsheetAttachedProperties), new PropertyMetadata(null, OnEmployeeWorkbookChanged));

        public static Workbook GetEmployeeWorkbook(DependencyObject obj)
        {
            return (Workbook)obj.GetValue(EmployeeWorkbookProperty);
        }

        public static void SetEmployeeWorkbook(DependencyObject obj, Workbook value)
        {
            obj.SetValue(EmployeeWorkbookProperty, value);
        }

        private static void OnEmployeeWorkbookChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            RadSpreadsheet spreadsheet = d as RadSpreadsheet;
            if (spreadsheet != null)
            {
                spreadsheet.Workbook = (Workbook)e.NewValue;
            }
        }
    }
}
